/*
 * Author: wangjian
 * 生成ServiceImpl
 */
package com.tofly.callcenter.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.callcenter.entity.Calllosscount;
import com.tofly.callcenter.mapper.CalllosscountMapper;
import com.tofly.callcenter.service.CalllosscountService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.List;

/**
 * 标识未接来电记录用作统计
 *
 * @author admin
 * @date Thu Sep 29 00:00:00 CST 2022
 */
@Service("calllosscountService")
@AllArgsConstructor
public class CalllosscountServiceImpl extends ServiceImpl<CalllosscountMapper, Calllosscount> implements CalllosscountService {

    /**
     * 未接来电数量统计接口
     *
     * @return long
     */
    @Override
    public Long calllosscount(String empcode) {
        empcode = StringUtils.isEmpty(empcode) ? null : empcode;
        List<Calllosscount> info = baseMapper.getInsertInfo(empcode);
        if (info != null && !info.isEmpty()) {
            saveBatch(info);
        }
        return baseMapper.calllosscount();
    }

    @Override
    public boolean updateFlag() {
        return update(Wrappers.<Calllosscount>lambdaUpdate()
                .set(Calllosscount::getFlag, "1")
                .eq(Calllosscount::getFlag, "0"));
    }
}
