/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.xrtygis.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 实际制气指标填报信息表
 *
 * @author admin
 * @date Wed Mar 10 00:00:00 CST 2021
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWPN_COSTRLWATER_W", resultMap = "costrlwaterMap")
@KeySequence("TF_YWPN_COSTRLWATER_W")
@ApiModel
public class Costrlwater extends Model<Costrlwater> {
    private static final long serialVersionUID = 1L;

    /**
     * 主键ID
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "主键ID")
    private Long id;
    /**
     * 填报日期
     */
    @ApiModelProperty(value = "填报日期")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private Date upDate;
    /**
     * 一厂供气量（万m³）
     */
    @ApiModelProperty(value = "一厂供气量（万m³）")
    private Double gslOne;
    /**
     * 二厂供气量（万m³）
     */
    @ApiModelProperty(value = "二厂供气量（万m³）")
    private Double gslTwo;
    /**
     * 青白江转供气（万m³）
     */
    @ApiModelProperty(value = "青白江转供气（万m³）")
    private Double gslQbj;
    /**
     * 总供气量（万m³）
     */
    @ApiModelProperty(value = "总供气量（万m³）")
    private Double gslTotal;
    /**
     * 一厂制气量（万m³）
     */
    @ApiModelProperty(value = "一厂制气量（万m³）")
    private Double zslOne;
    /**
     * 二厂制气量（万m³）
     */
    @ApiModelProperty(value = "二厂制气量（万m³）")
    private Double zslTwo;
    /**
     * 红旗气库制气量（万m³）
     */
    @ApiModelProperty(value = "红旗气库制气量（万m³）")
    private Double zslHqsk;
    /**
     * 总制气量（万m³）
     */
    @ApiModelProperty(value = "总制气量（万m³）")
    private Double zslTotal;
    /**
     * 售气量（万m³）
     */
    @ApiModelProperty(value = "售气量（万m³）")
    private Double sslTotal;
    /**
     * 一厂自用气量（万m³）
     */
    @ApiModelProperty(value = "一厂自用气量（万m³）")
    private Double zyslOne;
    /**
     * 二厂自用气量（万m³）
     */
    @ApiModelProperty(value = "二厂自用气量（万m³）")
    private Double zyslTwo;
    /**
     * 总自用气量（万m³）
     */
    @ApiModelProperty(value = "总自用气量（万m³）")
    private Double zyslTotal;
    /**
     * 一厂自用气率（%）
     */
    @ApiModelProperty(value = "一厂自用气率（%）")
    private Double zysllOne;
    /**
     * 二厂自用气率（%）
     */
    @ApiModelProperty(value = "二厂自用气率（%）")
    private Double zysllTwo;
    /**
     * 总自用气率（%）
     */
    @ApiModelProperty(value = "总自用气率（%）")
    private Double zysllTotal;
    /**
     * 未上盘气量（万m³）
     */
    @ApiModelProperty(value = "未上盘气量（万m³）")
    private Double wspsl;
    /**
     * 产销差（%）
     */
    @ApiModelProperty(value = "产销差（%）")
    private Double cxc;
    /**
     * 漏损率（%）
     */
    @ApiModelProperty(value = "漏损率（%）")
    private Double lsl;
    /**
     * 一厂PAC（kg）
     */
    @ApiModelProperty(value = "一厂PAC（kg）")
    private Double pacOne;
    /**
     * 二厂PAC（kg）
     */
    @ApiModelProperty(value = "二厂PAC（kg）")
    private Double pacTwo;
    /**
     * 一厂食盐（kg）
     */
    @ApiModelProperty(value = "一厂食盐（kg）")
    private Double syOne;
    /**
     * 二厂液氯（kg）
     */
    @ApiModelProperty(value = "二厂液氯（kg）")
    private Double ylTwo;
    /**
     * 制气PAM（kg）
     */
    @ApiModelProperty(value = "制气PAM（kg）")
    private Double pam;
    /**
     * 粉碳（kg）
     */
    @ApiModelProperty(value = "粉碳（kg）")
    private Double ft;
    /**
     * 次钠（kg）
     */
    @ApiModelProperty(value = "次钠（kg）")
    private Double cn;

    @ApiModelProperty("次钠二厂(kg)")
    private Double cnTwo;
    /**
     * 高锰酸钾复合盐（kg）
     */
    @ApiModelProperty(value = "高锰酸钾复合盐（kg）")
    private Double gmsjfhy;
    /**
     * 污泥PAM（kg）
     */
    @ApiModelProperty(value = "污泥PAM（kg）")
    private Double pamWy;
    /**
     * 冰醋酸（kg）
     */
    @ApiModelProperty(value = "冰醋酸（kg）")
    private Double bcs;
    /**
     * 污泥转量（m³）
     */
    @ApiModelProperty(value = "污泥转量（m³）")
    private Double wnzl;
    /**
     * 一厂动力电量（kwh）
     */
    @ApiModelProperty(value = "一厂动力电量（kwh）")
    private Double dldlOne;
    /**
     * 二厂动力电量（kwh）
     */
    @ApiModelProperty(value = "二厂动力电量（kwh）")
    private Double dldlTwo;
    /**
     * 总动力电量（kwh）
     */
    @ApiModelProperty(value = "总动力电量（kwh）")
    private Double dldlTotal;
    /**
     * 一厂基本电量（kwh）
     */
    @ApiModelProperty(value = "一厂基本电量（kwh）")
    private Double jbdlOne;
    /**
     * 二厂基本电量（kwh）
     */
    @ApiModelProperty(value = "二厂基本电量（kwh）")
    private Double jbdlTwo;
    /**
     * 总基本电量（kwh）
     */
    @ApiModelProperty(value = "总基本电量（kwh）")
    private Double jbdlTotal;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @TableField(value = "CREATE_TIME", fill = FieldFill.INSERT)
    private Date createTime;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    @TableField(value = "CREATE_USER", fill = FieldFill.INSERT)
    private Long createUser;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String createUserName;

    @ApiModelProperty("0,非财务填报，1,财务填报")
    private String mark;

    @ApiModelProperty("其他")
    private Double other;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("修改时间")
    private Date updateTime;

    private Double otherOne;
    private Double otherTwo;

}
