package com.tofly.xrtygis.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 气厂取供气关系表表结构表
 * @author 20126
 */
@Data
@ApiModel
@KeySequence("TF_YWPN_WORKRATOITEM_W")
@TableName(value = "TF_YWPN_WORKRATOITEM_W",resultMap = "workratoitemMap")
public class Workratoitem extends Model<Workratoitem> {
    /**
     * id
     */
    @TableId(value = "ID",type = IdType.INPUT)
    @ApiModelProperty(value = "id")
    private Long id;

    /**
     * 气厂id
     */
    @ApiModelProperty(value = "气厂id")
    private Long scid;

    /**
     * 类型：0，取气 1，供气
     */
    @ApiModelProperty(value = "类型：0，取气 1，供气")
    private Long type;

    /**
     * 指标编号
     */
    @ApiModelProperty(value = "指标编号")
    private String itcd;

    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField(value = "CREATE_TIME",fill = FieldFill.INSERT)
    private Date createTime;

    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    @TableField(value = "CREATE_USER",fill = FieldFill.INSERT)
    private Long createUser;
    @ApiModelProperty(hidden = true)
    private String createUserName;

}
