package com.tofly.watermeter.custom.service.meterBusiness.impl;

import cn.hutool.core.date.DateUnit;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.api.UserClent;
import com.tofly.common.core.util.DateUtil;
import com.tofly.common.oauth.exception.ToflyDeniedException;
import com.tofly.common.oauth.util.SecurityUtils;
import com.tofly.watermeter.custom.entity.meterBusiness.dto.ChangeTableBatchDto;
import com.tofly.watermeter.custom.entity.meterBusiness.dto.ChangeTableCondition;
import com.tofly.watermeter.custom.entity.meterBusiness.dto.ChangeTableDto;
import com.tofly.watermeter.custom.mapper.meterBusiness.ChangeTableMapper;
import com.tofly.watermeter.custom.service.meterBusiness.ChangeTableService;
import com.tofly.watermeter.custom.service.meterBusiness.export.ExportCommonCodeService;
import com.tofly.watermeter.entity.Bwhbdatail;
import com.tofly.watermeter.entity.Bwrksbdatail;
import com.tofly.watermeter.entity.Qfkhjbxx;
import com.tofly.watermeter.service.BwhbdatailService;
import com.tofly.watermeter.service.BwrksbdatailService;
import com.tofly.watermeter.service.QfkhjbxxService;
import com.tofly.watermeter.util.CallAPIUtil;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.StringUtils;

import javax.servlet.http.HttpServletResponse;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service
@AllArgsConstructor
public class ChangeTableServiceImpl implements ChangeTableService {

    private final QfkhjbxxService qfkhjbxxService;
    private final BwrksbdatailService bwrksbdatailService;
    private final BwhbdatailService bwhbdatailService;
    private final ChangeTableMapper changeTableMapper;
    private final ExportCommonCodeService exportCommonCodeService;
    private final UserClent userClent;

    /**
     * 气表换表
     *
     * @param dto dto
     * @return boolean
     * @throws Exception
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean changeTable(ChangeTableDto dto) throws Exception {

        if (StringUtils.isEmpty(dto.getYHBH())) {
            throw new ToflyDeniedException("用户编号为空");
        }

        Qfkhjbxx qfkhjbxx = qfkhjbxxService.getOne(Wrappers.<Qfkhjbxx>lambdaQuery()
                .eq(Qfkhjbxx::getYhbh, dto.getYHBH()));

        if (qfkhjbxx != null) {

//            if (StringUtils.isEmpty(qfkhjbxx.getSbbh())) {
//                throw new ToflyDeniedException("该用户未安装气表");
//            }

//            Bwrksbdatail one = bwrksbdatailService.getOne(Wrappers.<Bwrksbdatail>lambdaQuery()
//                    .eq(Bwrksbdatail::getBwSbbh, qfkhjbxx.getSbbh()));
//
//            if (one == null){
//                throw new ToflyDeniedException("该表未在库存中");
//            }

            String date = DateUtil.getDateFormat(new Date(), "yyyyMMdd-");

            dto.setACTION("QUERY");

            Map map = CallAPIUtil.callAPIUtil(dto, "/api/Business/WaterReplace");

            //0000代表添加成功
            if ("0000".equals(map.get("Code"))) {
                Bwhbdatail dbl = new Bwhbdatail();
                dbl.setAzfs(dto.getSBAZFS())
                        .setBwBz(dto.getBZ())
                        .setBwHblx(Long.valueOf(dto.getSBLX()))
                        .setBwKhbh(dto.getYHBH())
                        .setBwHbrq(new Date())
                        .setBwHbry(dto.getHBR())
                        .setBwHbyy(dto.getHBYY())
                        .setBwJbcj(qfkhjbxx.getSbcj())
                        .setBwJblx(qfkhjbxx.getSblx())
                        .setBwJbbh(qfkhjbxx.getSbbh())
                        .setBwJbkj(qfkhjbxx.getSbkj())
                        .setBwJbzd(Long.valueOf(dto.getJBZD()))
                        .setBwJbqd(Double.valueOf(dto.getJBQD()))
                        .setBwKhdz(qfkhjbxx.getYhdz())
                        .setBwKhdh(qfkhjbxx.getLxdh())
                        .setBwKhxm(qfkhjbxx.getYhxm())
                        .setBwHblx(Long.valueOf(dto.getSBLX()))
                        .setSqr(dto.getSQR())
                        .setHbsl(dto.getHBSL())
                        .setBwLsbh(date + System.currentTimeMillis())
                        .setJsfs(dto.getHBSLJSFS())
                        .setBwXbqd(Long.valueOf(dto.getXBQD()))
                        .setSbm(dto.getSBSBM())
                        .setQfh(dto.getSBQFH())
                        .setBwXbcj(dto.getSBMP())
                        .setBwXblx(dto.getSBLX())
                        .setSbxh(dto.getSBXH())
                        .setBwXbkj(dto.getSBKJ())
                        .setBwXbbh(dto.getSBBH())
                        .setJbAzrq(qfkhjbxx.getAzrq())
                        .setBwHbbm(changeTableMapper.getDeptId(Long.valueOf(dto.getHBR())));
                long betweenDay = cn.hutool.core.date.DateUtil.between(qfkhjbxx.getAzrq(), dbl.getBwHbrq(), DateUnit.DAY);
                dbl.setSyDate(betweenDay);

                bwhbdatailService.save(dbl);

                Long departmentId = userClent.getById(Long.valueOf(dto.getHBR())).getResult().getDepartmentId();

                Bwrksbdatail bwrksbdatail = bwrksbdatailService.getOne(Wrappers.<Bwrksbdatail>lambdaQuery().eq(Bwrksbdatail::getBwSbbh, dto.getSBBH()));

                if (bwrksbdatail != null) {
                    bwrksbdatail.setBwKhbh(dto.getYHBH()).setBwKhxm(qfkhjbxx.getYhxm()).setBwKhdh(qfkhjbxx.getLxdh())
                            .setBwKhdz(qfkhjbxx.getYhdz()).setBwAzry(Long.valueOf(dto.getHBR())).setBwSbqd(Integer.valueOf(dto.getXBQD()))
                            .setAzfs(dto.getSBAZFS()).setSfncys(qfkhjbxx.getSfncys()).setJyz(qfkhjbxx.getJyz()).setAzbm(departmentId)
                            .setGddh(qfkhjbxx.getLxdh()).setSbazdz(qfkhjbxx.getYhdz()).setIssyc("1").setMsg("成功").setBwSbzt("3").setBwAzrq(new Date());

                    bwrksbdatailService.updateById(bwrksbdatail);
                }
               /* bwrksbdatailService.update(Wrappers.<Bwrksbdatail>lambdaUpdate()
                        .set(Bwrksbdatail::getBwKhbh, dto.getYHBH())
                        .set(Bwrksbdatail::getBwKhxm, qfkhjbxx.getYhxm())
                        .set(Bwrksbdatail::getBwKhdh, qfkhjbxx.getLxdh())
                        .set(Bwrksbdatail::getBwKhdz, qfkhjbxx.getYhdz())
                        .set(Bwrksbdatail::getGddh, qfkhjbxx.getLxdh())
                        .set(Bwrksbdatail::getBwAzrq, new Date())
                        .set(Bwrksbdatail::getBwAzry, Long.valueOf(dto.getHBR()))
                        .set(Bwrksbdatail::getBwSbqd, Integer.valueOf(dto.getXBQD()))
                        .set(Bwrksbdatail::getAzfs, dto.getSBAZFS())
                        .set(Bwrksbdatail::getSfncys, qfkhjbxx.getSfncys())
                        .set(Bwrksbdatail::getJyz, qfkhjbxx.getJyz())
                        .set(Bwrksbdatail::getSbazdz, qfkhjbxx.getYhdz())
                        .set(Bwrksbdatail::getAzbm, departmentId)
                        .set(Bwrksbdatail::getIssyc, '1')
                        .set(Bwrksbdatail::getMsg, "成功")
                        .set(Bwrksbdatail::getBwSbzt, '3')
                        .eq(Bwrksbdatail::getBwSbbh, dto.getSBBH()));*/

                //旧表改为换表状态
                bwrksbdatailService.update(Wrappers.<Bwrksbdatail>lambdaUpdate()
                        .eq(Bwrksbdatail::getBwSbbh, qfkhjbxx.getSbbh()).set(Bwrksbdatail::getBwSbzt, 9));

            } else {
                throw new ToflyDeniedException(map.get("message").toString());
            }
        } else {
            throw new ToflyDeniedException("用户不存在");
        }
        return true;
    }

    /**
     * 批量换表
     *
     * @return Boolean
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean changeTableBatch(ChangeTableBatchDto changeTableBatchDto) {

        if (changeTableBatchDto == null || changeTableBatchDto.getInfos() == null || changeTableBatchDto.getInfos().isEmpty()) {
            throw new ToflyDeniedException("传入数据为空");
        }

        List<ChangeTableDto> dtoList = changeTableBatchDto.getInfos();

        Bwhbdatail dbl;

        for (ChangeTableDto dto : dtoList) {
            if (StringUtils.isEmpty(dto.getYHBH())) {
                throw new ToflyDeniedException("用户编号为空");
            }

            dbl = new Bwhbdatail();

            Qfkhjbxx qfkhjbxx = qfkhjbxxService.getOne(Wrappers.<Qfkhjbxx>lambdaQuery()
                    .eq(Qfkhjbxx::getYhbh, dto.getYHBH()));


            String date = DateUtil.getDateFormat(new Date(), "yyyyMMdd-");

            dto.setACTION("QUERY");

            Map map = null;
            try {
                map = CallAPIUtil.callAPIUtil(dto, "/api/Business/WaterReplace");
            } catch (Exception e) {
                e.printStackTrace();
            }
            //同步默认信息
            dbl.setIsSync(0L);
            dbl.setMsg("同步失败:调用失败");

            if (map != null && !map.isEmpty()) {
                //0000代表添加成功
                if ("0000".equals(map.get("Code"))) {
                    dbl.setIsSync(1L);
                }
                dbl.setMsg(map.get("message").toString());
            }

            if (qfkhjbxx != null) {
                long betweenDay = cn.hutool.core.date.DateUtil.between(qfkhjbxx.getAzrq(), dbl.getBwHbrq(), DateUnit.DAY);
                dbl.setBwJbcj(qfkhjbxx.getSbcj())
                        .setBwJblx(qfkhjbxx.getSblx())
                        .setBwJbbh(qfkhjbxx.getSbbh())
                        .setBwJbkj(qfkhjbxx.getSbkj())
                        .setBwKhdz(qfkhjbxx.getYhdz())
                        .setSyDate(betweenDay)
                        .setBwKhdh(qfkhjbxx.getLxdh())
                        .setJbAzrq(qfkhjbxx.getAzrq())
                        .setBwKhxm(qfkhjbxx.getYhxm());
            }
            Long userId = SecurityUtils.getUserId();

            dbl.setAzfs(dto.getSBAZFS())
                    .setBwBz(dto.getBZ())
                    .setBwHblx(dto.getSBLX() != null ? Long.valueOf(dto.getSBLX()) : null)
                    .setBwKhbh(dto.getYHBH())
                    .setBwHbrq(new Date())
                    .setBwHbry(dto.getHBR())
                    .setBwHbyy(dto.getHBYY())
                    .setBwJbzd(dto.getJBZD() != null ? Long.valueOf(dto.getJBZD()) : null)
                    .setBwJbqd(dto.getJBQD() != null ? Double.valueOf(dto.getJBQD()) : null)
                    .setSqr(dto.getSQR())
                    .setHbsl(dto.getHBSL())
                    .setBwLsbh(date + System.currentTimeMillis())
                    .setJsfs(dto.getHBSLJSFS())
                    .setBwXbqd(dto.getXBQD() != null ? Long.valueOf(dto.getXBQD()) : null)
                    .setSbm(dto.getSBSBM())
                    .setQfh(dto.getSBQFH())
                    .setBwXbcj(dto.getSBMP())
                    .setBwXblx(dto.getSBLX())
                    .setSbxh(dto.getSBXH())
                    .setBwXbkj(dto.getSBKJ())
                    .setBwXbbh(dto.getSBBH())
                    .setCreateUser(userId)
                    .setBwHbbm(dto.getHBR() != null ? changeTableMapper.getDeptId(Long.valueOf(dto.getHBR())) : null);

            bwhbdatailService.save(dbl);

            Long departmentId = 0L;
            if (dto.getHBR() != null){
                departmentId = userClent.getById(Long.valueOf(dto.getHBR())).getResult().getDepartmentId();
            }

            Bwrksbdatail bwrksbdatail = bwrksbdatailService.getOne(Wrappers.<Bwrksbdatail>lambdaQuery().eq(Bwrksbdatail::getBwSbbh, dto.getSBBH()));

            if (bwrksbdatail != null) {
                bwrksbdatail.setBwKhbh(dto.getYHBH())
                        .setBwKhxm(qfkhjbxx != null ? qfkhjbxx.getYhxm() : "")
                        .setBwKhdh(qfkhjbxx != null ?qfkhjbxx.getLxdh(): "")
                        .setBwKhdz(qfkhjbxx != null ?qfkhjbxx.getYhdz(): "")
                        .setBwAzry(StringUtils.isEmpty(dto.getHBR()) ? 0L :Long.parseLong(dto.getHBR()))
                        .setBwSbqd(StringUtils.isEmpty(dto.getXBQD()) ? 0 :Integer.parseInt(dto.getXBQD()))
                        .setAzfs(dto.getSBAZFS())
                        .setSfncys(qfkhjbxx != null ?qfkhjbxx.getSfncys(): "")
                        .setJyz(qfkhjbxx != null ?qfkhjbxx.getJyz(): "")
                        .setAzbm(departmentId)
                        .setGddh(qfkhjbxx != null ?qfkhjbxx.getLxdh(): "")
                        .setSbazdz(qfkhjbxx != null ?qfkhjbxx.getYhdz(): "")
                        .setIssyc("1").setMsg("成功")
                        .setBwSbzt("3").setBwAzrq(new Date());

                bwrksbdatailService.updateById(bwrksbdatail);
            }

            String sbbh = "-1";
            if (qfkhjbxx != null) {
                sbbh = qfkhjbxx.getSbbh();
            }
            //旧表改为换表状态
            bwrksbdatailService.update(Wrappers.<Bwrksbdatail>lambdaUpdate()
                    .eq(Bwrksbdatail::getBwSbbh, sbbh).set(Bwrksbdatail::getBwSbzt, 9));
        }
//        ThreadPoolUtil.executorService.execute(() -> {
//
//        });

        return true;
    }

    /**
     * 查询安装气表用户
     *
     * @param dto 查询条件
     * @return list
     */
    @Override
    public Page<Map> queryInfo(Page page, String dto, String sbkj, String sblx, String sbcj) {
        return qfkhjbxxService.page(page, Wrappers.<Qfkhjbxx>lambdaQuery()
                .ne(Qfkhjbxx::getYhzt, 9)
                .eq(!StringUtils.isEmpty(sbcj), Qfkhjbxx::getSbcj, sbcj)
                .eq(!StringUtils.isEmpty(sbkj), Qfkhjbxx::getSbkj, sbkj)
                .eq(!StringUtils.isEmpty(sblx), Qfkhjbxx::getSblx, sblx)
                .and(!StringUtils.isEmpty(dto), v -> v.like(Qfkhjbxx::getYhbh, dto)
                        .or().like(Qfkhjbxx::getYhxm, dto)
                        .or().like(Qfkhjbxx::getYhdz, dto)
                        .or().like(Qfkhjbxx::getLxdh, dto)
                        .or().like(Qfkhjbxx::getSbbh, dto)));
    }

    @Override
    public List<Map> countChangeTable(HttpServletResponse response, ChangeTableCondition dto) {
        List<Map> maps = changeTableMapper.countChangeTable(dto);
        if (dto.getExport() != null && dto.getExport() == 1) {
            exportCommonCodeService.exportCode(response, "countChangeTableService", maps);
        }
        return maps;
    }

    @Override
    public Page<Map> queryChangeTable(Page page, HttpServletResponse response, ChangeTableCondition dto) {
        Page<Map> mapPage = changeTableMapper.queryChangeTable(page, dto);
        if (dto.getExport() == 1) {
            exportCommonCodeService.exportCode(response, "queryChangeTableService", mapPage.getRecords());
        }
        return mapPage;
    }
}
