package com.tofly.watermeter.em;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * @author FlashWJL
 * @date 2021/12/1 14:34
 */
@Getter
@AllArgsConstructor
public enum AbnormalEnum {
    SLTSMX("14","气量突升模型","气量突升/降比列模型",992L , 965L),
    SLTJMX("1","气量突降模型","气量突升/降比列模型",975L , 965L),
    TBSMX("2","同比升模型","同比升/降比例模型",976L , 966L),
    TBJMX("3","同比降模型","同比升/降比例模型",977L , 966L),
    HBSMX("4","环比升模型","环比升/降比例模型",978L , 967L),
    HBJMX("5","环比降模型","环比升/降比例模型",979L , 967L),
    LSLMX("6","0气量模型","0气量模型",980L , 968L),
    HBMX("7","换表模型","换表模型",981L , 969L),
    GSMX("8","估气模型","估气模型",982L , 970L),
    SLWFBDMX("9","气量微幅波动模型","气量微幅波动模型",983L , 971L),
    SLLXSSMX("10","气量连续上升模型","气量连续升/降模型",984L , 972L),
    SLLXXJMX("11","气量连续下降模型","气量连续升/降模型",985L , 972L),
    SCSLMX("12","首次气量模型","首次查抄气量模型",986L , 973L),
    LXSLXTMX("13","连续气量相同模型","连续气量相同模型",987L , 974L),
    ;



    @ApiModelProperty(value = "异常算法类型code，1：气量突降数据2：同比升数据3：同比降数据4：环比升数据5：环比降数据6:0气量模型7：换表数据8：估气数据9：气量微幅波动数据10：气量连续上升数据11：气量连续下降数据12：首次气量数据13：连续气量向相同数据14：气量突升数据")
    private String typeCode;
    @ApiModelProperty(value = "异常算法类型名称")
    private String typeState;
    @ApiModelProperty(value = "模型名称")
    private String modelName;
    @ApiModelProperty(value = "异常算法类型ID")
    private Long typeId;
    @ApiModelProperty(value = "异常模型大类ID")
    private Long bigTypeId;

}
