/*
 * Author: wangjian
 * 生成Service
 */
package com.tofly.xrtymis.custom.service;


import com.tofly.common.core.entity.ResultRespone;
import com.tofly.pojo.comm.Audit;
import com.tofly.pojo.plan.Checkhistory;
import com.tofly.pojo.plan.vo.CheckhistoryVo;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.Date;
import java.util.List;


/**
 * 审核记录历史表
 *
 * @author admin
 * @date Tue Mar 30 00:00:00 CST 2021
 */
public interface CheckhistoryService extends IBaseService<Checkhistory, CheckhistoryVo> {
    /**
     * 审批记录插入
     *
     * @param type        类型
     * @param checkId     id
     * @param auditResult 审批结果
     * @param auditNotes  审批说明
     * @param auditUser   审批人
     * @param auditTime   审批时间
     * @return
     */
    boolean recordHis(String type, Long checkId, String auditResult, String auditNotes, Long auditUser, Date auditTime);

    boolean delete(String type, Long planId);

    ResultRespone<List<Audit>> getAuditInfo(Audit audit);

    boolean update(Audit audit);

    boolean saveAuditHisInfo(Checkhistory checkhistory);

    boolean save(String json);

    ResultRespone<Object> getAuditHisInfo( Checkhistory checkhistory);
}
